3ffe6de66bd6cb1ee36170f54aeb9a1a4fb5ef29
[openwrt/staging/stintel.git] / package / kernel / mac80211 / files / lib / netifd / wireless / mac80211.sh
1 #!/bin/sh
2 . /lib/netifd/netifd-wireless.sh
3 . /lib/netifd/hostapd.sh
4
5 init_wireless_driver "$@"
6
7 MP_CONFIG_INT="mesh_retry_timeout mesh_confirm_timeout mesh_holding_timeout mesh_max_peer_links
8 mesh_max_retries mesh_ttl mesh_element_ttl mesh_hwmp_max_preq_retries
9 mesh_path_refresh_time mesh_min_discovery_timeout mesh_hwmp_active_path_timeout
10 mesh_hwmp_preq_min_interval mesh_hwmp_net_diameter_traversal_time mesh_hwmp_rootmode
11 mesh_hwmp_rann_interval mesh_gate_announcements mesh_sync_offset_max_neighor
12 mesh_rssi_threshold mesh_hwmp_active_path_to_root_timeout mesh_hwmp_root_interval
13 mesh_hwmp_confirmation_interval mesh_awake_window mesh_plink_timeout"
14 MP_CONFIG_BOOL="mesh_auto_open_plinks mesh_fwding"
15 MP_CONFIG_STRING="mesh_power_mode"
16
17 NEWAPLIST=
18 OLDAPLIST=
19 NEWSPLIST=
20 OLDSPLIST=
21 NEWUMLIST=
22 OLDUMLIST=
23
24 drv_mac80211_init_device_config() {
25 hostapd_common_add_device_config
26
27 config_add_string path phy 'macaddr:macaddr'
28 config_add_string tx_burst
29 config_add_string distance
30 config_add_int beacon_int chanbw frag rts
31 config_add_int rxantenna txantenna antenna_gain txpower
32 config_add_boolean noscan ht_coex acs_exclude_dfs background_radar
33 config_add_array ht_capab
34 config_add_array channels
35 config_add_array scan_list
36 config_add_boolean \
37 rxldpc \
38 short_gi_80 \
39 short_gi_160 \
40 tx_stbc_2by1 \
41 su_beamformer \
42 su_beamformee \
43 mu_beamformer \
44 mu_beamformee \
45 he_su_beamformer \
46 he_su_beamformee \
47 he_mu_beamformer \
48 vht_txop_ps \
49 htc_vht \
50 rx_antenna_pattern \
51 tx_antenna_pattern \
52 he_spr_sr_control \
53 he_twt_required
54 config_add_int \
55 beamformer_antennas \
56 beamformee_antennas \
57 vht_max_a_mpdu_len_exp \
58 vht_max_mpdu \
59 vht_link_adapt \
60 vht160 \
61 rx_stbc \
62 tx_stbc \
63 he_bss_color \
64 he_spr_non_srg_obss_pd_max_offset
65 config_add_boolean \
66 ldpc \
67 greenfield \
68 short_gi_20 \
69 short_gi_40 \
70 max_amsdu \
71 dsss_cck_40
72 }
73
74 drv_mac80211_init_iface_config() {
75 hostapd_common_add_bss_config
76
77 config_add_string 'macaddr:macaddr' ifname
78
79 config_add_boolean wds powersave enable
80 config_add_string wds_bridge
81 config_add_int maxassoc
82 config_add_int max_listen_int
83 config_add_int dtim_period
84 config_add_int start_disabled
85
86 # mesh
87 config_add_string mesh_id
88 config_add_int $MP_CONFIG_INT
89 config_add_boolean $MP_CONFIG_BOOL
90 config_add_string $MP_CONFIG_STRING
91 }
92
93 mac80211_add_capabilities() {
94 local __var="$1"; shift
95 local __mask="$1"; shift
96 local __out= oifs
97
98 oifs="$IFS"
99 IFS=:
100 for capab in "$@"; do
101 set -- $capab
102
103 [ "$(($4))" -gt 0 ] || continue
104 [ "$(($__mask & $2))" -eq "$((${3:-$2}))" ] || continue
105 __out="$__out[$1]"
106 done
107 IFS="$oifs"
108
109 export -n -- "$__var=$__out"
110 }
111
112 mac80211_add_he_capabilities() {
113 local __out= oifs
114
115 oifs="$IFS"
116 IFS=:
117 for capab in "$@"; do
118 set -- $capab
119 [ "$(($4))" -gt 0 ] || continue
120 [ "$(((0x$2) & $3))" -gt 0 ] || {
121 eval "$1=0"
122 continue
123 }
124 append base_cfg "$1=1" "$N"
125 done
126 IFS="$oifs"
127 }
128
129 mac80211_hostapd_setup_base() {
130 local phy="$1"
131
132 json_select config
133
134 [ "$auto_channel" -gt 0 ] && channel=acs_survey
135
136 [ "$auto_channel" -gt 0 ] && json_get_vars acs_exclude_dfs
137 [ -n "$acs_exclude_dfs" ] && [ "$acs_exclude_dfs" -gt 0 ] &&
138 append base_cfg "acs_exclude_dfs=1" "$N"
139
140 json_get_vars noscan ht_coex
141 json_get_values ht_capab_list ht_capab tx_burst
142 json_get_values channel_list channels
143
144 [ "$auto_channel" = 0 ] && [ -z "$channel_list" ] && \
145 channel_list="$channel"
146
147 set_default noscan 0
148
149 [ "$noscan" -gt 0 ] && hostapd_noscan=1
150 [ "$tx_burst" = 0 ] && tx_burst=
151
152 chan_ofs=0
153 [ "$band" = "6g" ] && chan_ofs=1
154
155 ieee80211n=1
156 ht_capab=
157 case "$htmode" in
158 VHT20|HT20|HE20) ;;
159 HT40*|VHT40|VHT80|VHT160|HE40|HE80|HE160)
160 case "$hwmode" in
161 a)
162 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
163 1) ht_capab="[HT40+]";;
164 0) ht_capab="[HT40-]";;
165 esac
166 ;;
167 *)
168 case "$htmode" in
169 HT40+) ht_capab="[HT40+]";;
170 HT40-) ht_capab="[HT40-]";;
171 *)
172 if [ "$channel" -lt 7 ]; then
173 ht_capab="[HT40+]"
174 else
175 ht_capab="[HT40-]"
176 fi
177 ;;
178 esac
179 ;;
180 esac
181 [ "$auto_channel" -gt 0 ] && ht_capab="[HT40+]"
182 ;;
183 *) ieee80211n= ;;
184 esac
185
186 [ -n "$ieee80211n" ] && {
187 append base_cfg "ieee80211n=1" "$N"
188
189 set_default ht_coex 0
190 append base_cfg "ht_coex=$ht_coex" "$N"
191
192 json_get_vars \
193 ldpc:1 \
194 greenfield:0 \
195 short_gi_20:1 \
196 short_gi_40:1 \
197 tx_stbc:1 \
198 rx_stbc:3 \
199 max_amsdu:1 \
200 dsss_cck_40:1
201
202 ht_cap_mask=0
203 for cap in $(iw phy "$phy" info | grep 'Capabilities:' | cut -d: -f2); do
204 ht_cap_mask="$(($ht_cap_mask | $cap))"
205 done
206
207 cap_rx_stbc=$((($ht_cap_mask >> 8) & 3))
208 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
209 ht_cap_mask="$(( ($ht_cap_mask & ~(0x300)) | ($cap_rx_stbc << 8) ))"
210
211 mac80211_add_capabilities ht_capab_flags $ht_cap_mask \
212 LDPC:0x1::$ldpc \
213 GF:0x10::$greenfield \
214 SHORT-GI-20:0x20::$short_gi_20 \
215 SHORT-GI-40:0x40::$short_gi_40 \
216 TX-STBC:0x80::$tx_stbc \
217 RX-STBC1:0x300:0x100:1 \
218 RX-STBC12:0x300:0x200:1 \
219 RX-STBC123:0x300:0x300:1 \
220 MAX-AMSDU-7935:0x800::$max_amsdu \
221 DSSS_CCK-40:0x1000::$dsss_cck_40
222
223 ht_capab="$ht_capab$ht_capab_flags"
224 [ -n "$ht_capab" ] && append base_cfg "ht_capab=$ht_capab" "$N"
225 }
226
227 # 802.11ac
228 enable_ac=0
229 vht_oper_chwidth=0
230 vht_center_seg0=
231
232 idx="$channel"
233 case "$htmode" in
234 VHT20|HE20) enable_ac=1;;
235 VHT40|HE40)
236 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
237 1) idx=$(($channel + 2));;
238 0) idx=$(($channel - 2));;
239 esac
240 enable_ac=1
241 vht_center_seg0=$idx
242 ;;
243 VHT80|HE80)
244 case "$(( (($channel / 4) + $chan_ofs) % 4 ))" in
245 1) idx=$(($channel + 6));;
246 2) idx=$(($channel + 2));;
247 3) idx=$(($channel - 2));;
248 0) idx=$(($channel - 6));;
249 esac
250 enable_ac=1
251 vht_oper_chwidth=1
252 vht_center_seg0=$idx
253 ;;
254 VHT160|HE160)
255 if [ "$band" = "6g" ]; then
256 case "$channel" in
257 1|5|9|13|17|21|25|29) idx=15;;
258 33|37|41|45|49|53|57|61) idx=47;;
259 65|69|73|77|81|85|89|93) idx=79;;
260 97|101|105|109|113|117|121|125) idx=111;;
261 129|133|137|141|145|149|153|157) idx=143;;
262 161|165|169|173|177|181|185|189) idx=175;;
263 193|197|201|205|209|213|217|221) idx=207;;
264 esac
265 else
266 case "$channel" in
267 36|40|44|48|52|56|60|64) idx=50;;
268 100|104|108|112|116|120|124|128) idx=114;;
269 esac
270 fi
271 enable_ac=1
272 vht_oper_chwidth=2
273 vht_center_seg0=$idx
274 ;;
275 esac
276 [ "$band" = "5g" ] && {
277 json_get_vars background_radar:0
278
279 [ "$background_radar" -eq 1 ] && append base_cfg "enable_background_radar=1" "$N"
280 }
281 [ "$band" = "6g" ] && {
282 op_class=
283 case "$htmode" in
284 HE20) op_class=131;;
285 HE*) op_class=$((132 + $vht_oper_chwidth))
286 esac
287 [ -n "$op_class" ] && append base_cfg "op_class=$op_class" "$N"
288 }
289 [ "$hwmode" = "a" ] || enable_ac=0
290
291 if [ "$enable_ac" != "0" ]; then
292 json_get_vars \
293 rxldpc:1 \
294 short_gi_80:1 \
295 short_gi_160:1 \
296 tx_stbc_2by1:1 \
297 su_beamformer:1 \
298 su_beamformee:1 \
299 mu_beamformer:1 \
300 mu_beamformee:1 \
301 vht_txop_ps:1 \
302 htc_vht:1 \
303 beamformee_antennas:4 \
304 beamformer_antennas:4 \
305 rx_antenna_pattern:1 \
306 tx_antenna_pattern:1 \
307 vht_max_a_mpdu_len_exp:7 \
308 vht_max_mpdu:11454 \
309 rx_stbc:4 \
310 vht_link_adapt:3 \
311 vht160:2
312
313 set_default tx_burst 2.0
314 append base_cfg "ieee80211ac=1" "$N"
315 vht_cap=0
316 for cap in $(iw phy "$phy" info | awk -F "[()]" '/VHT Capabilities/ { print $2 }'); do
317 vht_cap="$(($vht_cap | $cap))"
318 done
319
320 append base_cfg "vht_oper_chwidth=$vht_oper_chwidth" "$N"
321 append base_cfg "vht_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
322
323 cap_rx_stbc=$((($vht_cap >> 8) & 7))
324 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
325 vht_cap="$(( ($vht_cap & ~(0x700)) | ($cap_rx_stbc << 8) ))"
326
327 mac80211_add_capabilities vht_capab $vht_cap \
328 RXLDPC:0x10::$rxldpc \
329 SHORT-GI-80:0x20::$short_gi_80 \
330 SHORT-GI-160:0x40::$short_gi_160 \
331 TX-STBC-2BY1:0x80::$tx_stbc_2by1 \
332 SU-BEAMFORMER:0x800::$su_beamformer \
333 SU-BEAMFORMEE:0x1000::$su_beamformee \
334 MU-BEAMFORMER:0x80000::$mu_beamformer \
335 MU-BEAMFORMEE:0x100000::$mu_beamformee \
336 VHT-TXOP-PS:0x200000::$vht_txop_ps \
337 HTC-VHT:0x400000::$htc_vht \
338 RX-ANTENNA-PATTERN:0x10000000::$rx_antenna_pattern \
339 TX-ANTENNA-PATTERN:0x20000000::$tx_antenna_pattern \
340 RX-STBC-1:0x700:0x100:1 \
341 RX-STBC-12:0x700:0x200:1 \
342 RX-STBC-123:0x700:0x300:1 \
343 RX-STBC-1234:0x700:0x400:1 \
344
345 [ "$(($vht_cap & 0x800))" -gt 0 -a "$su_beamformer" -gt 0 ] && {
346 cap_ant="$(( ( ($vht_cap >> 16) & 3 ) + 1 ))"
347 [ "$cap_ant" -gt "$beamformer_antennas" ] && cap_ant="$beamformer_antennas"
348 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[SOUNDING-DIMENSION-$cap_ant]"
349 }
350
351 [ "$(($vht_cap & 0x1000))" -gt 0 -a "$su_beamformee" -gt 0 ] && {
352 cap_ant="$(( ( ($vht_cap >> 13) & 3 ) + 1 ))"
353 [ "$cap_ant" -gt "$beamformee_antennas" ] && cap_ant="$beamformee_antennas"
354 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[BF-ANTENNA-$cap_ant]"
355 }
356
357 # supported Channel widths
358 vht160_hw=0
359 [ "$(($vht_cap & 12))" -eq 4 -a 1 -le "$vht160" ] && \
360 vht160_hw=1
361 [ "$(($vht_cap & 12))" -eq 8 -a 2 -le "$vht160" ] && \
362 vht160_hw=2
363 [ "$vht160_hw" = 1 ] && vht_capab="$vht_capab[VHT160]"
364 [ "$vht160_hw" = 2 ] && vht_capab="$vht_capab[VHT160-80PLUS80]"
365
366 # maximum MPDU length
367 vht_max_mpdu_hw=3895
368 [ "$(($vht_cap & 3))" -ge 1 -a 7991 -le "$vht_max_mpdu" ] && \
369 vht_max_mpdu_hw=7991
370 [ "$(($vht_cap & 3))" -ge 2 -a 11454 -le "$vht_max_mpdu" ] && \
371 vht_max_mpdu_hw=11454
372 [ "$vht_max_mpdu_hw" != 3895 ] && \
373 vht_capab="$vht_capab[MAX-MPDU-$vht_max_mpdu_hw]"
374
375 # maximum A-MPDU length exponent
376 vht_max_a_mpdu_len_exp_hw=0
377 [ "$(($vht_cap & 58720256))" -ge 8388608 -a 1 -le "$vht_max_a_mpdu_len_exp" ] && \
378 vht_max_a_mpdu_len_exp_hw=1
379 [ "$(($vht_cap & 58720256))" -ge 16777216 -a 2 -le "$vht_max_a_mpdu_len_exp" ] && \
380 vht_max_a_mpdu_len_exp_hw=2
381 [ "$(($vht_cap & 58720256))" -ge 25165824 -a 3 -le "$vht_max_a_mpdu_len_exp" ] && \
382 vht_max_a_mpdu_len_exp_hw=3
383 [ "$(($vht_cap & 58720256))" -ge 33554432 -a 4 -le "$vht_max_a_mpdu_len_exp" ] && \
384 vht_max_a_mpdu_len_exp_hw=4
385 [ "$(($vht_cap & 58720256))" -ge 41943040 -a 5 -le "$vht_max_a_mpdu_len_exp" ] && \
386 vht_max_a_mpdu_len_exp_hw=5
387 [ "$(($vht_cap & 58720256))" -ge 50331648 -a 6 -le "$vht_max_a_mpdu_len_exp" ] && \
388 vht_max_a_mpdu_len_exp_hw=6
389 [ "$(($vht_cap & 58720256))" -ge 58720256 -a 7 -le "$vht_max_a_mpdu_len_exp" ] && \
390 vht_max_a_mpdu_len_exp_hw=7
391 vht_capab="$vht_capab[MAX-A-MPDU-LEN-EXP$vht_max_a_mpdu_len_exp_hw]"
392
393 # whether or not the STA supports link adaptation using VHT variant
394 vht_link_adapt_hw=0
395 [ "$(($vht_cap & 201326592))" -ge 134217728 -a 2 -le "$vht_link_adapt" ] && \
396 vht_link_adapt_hw=2
397 [ "$(($vht_cap & 201326592))" -ge 201326592 -a 3 -le "$vht_link_adapt" ] && \
398 vht_link_adapt_hw=3
399 [ "$vht_link_adapt_hw" != 0 ] && \
400 vht_capab="$vht_capab[VHT-LINK-ADAPT-$vht_link_adapt_hw]"
401
402 [ -n "$vht_capab" ] && append base_cfg "vht_capab=$vht_capab" "$N"
403 fi
404
405 # 802.11ax
406 enable_ax=0
407 case "$htmode" in
408 HE*) enable_ax=1 ;;
409 esac
410
411 if [ "$enable_ax" != "0" ]; then
412 json_get_vars \
413 he_su_beamformer:1 \
414 he_su_beamformee:0 \
415 he_mu_beamformer:1 \
416 he_twt_required:0 \
417 he_spr_sr_control:0 \
418 he_spr_non_srg_obss_pd_max_offset:1 \
419 he_bss_color
420
421 he_phy_cap=$(iw phy "$phy" info | awk -F "[()]" '/HE PHY Capabilities/ { print $2 }' | head -1)
422 he_phy_cap=${he_phy_cap:2}
423 he_mac_cap=$(iw phy "$phy" info | awk -F "[()]" '/HE MAC Capabilities/ { print $2 }' | head -1)
424 he_mac_cap=${he_mac_cap:2}
425
426 append base_cfg "ieee80211ax=1" "$N"
427 [ "$hwmode" = "a" ] && {
428 append base_cfg "he_oper_chwidth=$vht_oper_chwidth" "$N"
429 append base_cfg "he_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
430 }
431
432 set_default he_bss_color 128
433 append base_cfg "he_bss_color=$he_bss_color" "$N"
434
435 mac80211_add_he_capabilities \
436 he_su_beamformer:${he_phy_cap:6:2}:0x80:$he_su_beamformer \
437 he_su_beamformee:${he_phy_cap:8:2}:0x1:$he_su_beamformee \
438 he_mu_beamformer:${he_phy_cap:8:2}:0x2:$he_mu_beamformer \
439 he_spr_sr_control:${he_phy_cap:14:2}:0x1:$he_spr_sr_control \
440 he_twt_required:${he_mac_cap:0:2}:0x6:$he_twt_required
441
442 [ "$he_spr_sr_control" -gt 0 ] && append base_cfg "he_spr_non_srg_obss_pd_max_offset=$he_spr_non_srg_obss_pd_max_offset" "$N"
443
444 append base_cfg "he_default_pe_duration=4" "$N"
445 append base_cfg "he_rts_threshold=1023" "$N"
446 append base_cfg "he_mu_edca_qos_info_param_count=0" "$N"
447 append base_cfg "he_mu_edca_qos_info_q_ack=0" "$N"
448 append base_cfg "he_mu_edca_qos_info_queue_request=0" "$N"
449 append base_cfg "he_mu_edca_qos_info_txop_request=0" "$N"
450 append base_cfg "he_mu_edca_ac_be_aifsn=8" "$N"
451 append base_cfg "he_mu_edca_ac_be_aci=0" "$N"
452 append base_cfg "he_mu_edca_ac_be_ecwmin=9" "$N"
453 append base_cfg "he_mu_edca_ac_be_ecwmax=10" "$N"
454 append base_cfg "he_mu_edca_ac_be_timer=255" "$N"
455 append base_cfg "he_mu_edca_ac_bk_aifsn=15" "$N"
456 append base_cfg "he_mu_edca_ac_bk_aci=1" "$N"
457 append base_cfg "he_mu_edca_ac_bk_ecwmin=9" "$N"
458 append base_cfg "he_mu_edca_ac_bk_ecwmax=10" "$N"
459 append base_cfg "he_mu_edca_ac_bk_timer=255" "$N"
460 append base_cfg "he_mu_edca_ac_vi_ecwmin=5" "$N"
461 append base_cfg "he_mu_edca_ac_vi_ecwmax=7" "$N"
462 append base_cfg "he_mu_edca_ac_vi_aifsn=5" "$N"
463 append base_cfg "he_mu_edca_ac_vi_aci=2" "$N"
464 append base_cfg "he_mu_edca_ac_vi_timer=255" "$N"
465 append base_cfg "he_mu_edca_ac_vo_aifsn=5" "$N"
466 append base_cfg "he_mu_edca_ac_vo_aci=3" "$N"
467 append base_cfg "he_mu_edca_ac_vo_ecwmin=5" "$N"
468 append base_cfg "he_mu_edca_ac_vo_ecwmax=7" "$N"
469 append base_cfg "he_mu_edca_ac_vo_timer=255" "$N"
470 fi
471
472 hostapd_prepare_device_config "$hostapd_conf_file" nl80211
473 cat >> "$hostapd_conf_file" <<EOF
474 ${channel:+channel=$channel}
475 ${channel_list:+chanlist=$channel_list}
476 ${hostapd_noscan:+noscan=1}
477 ${tx_burst:+tx_queue_data2_burst=$tx_burst}
478 $base_cfg
479
480 EOF
481 json_select ..
482 radio_md5sum=$(md5sum $hostapd_conf_file | cut -d" " -f1)
483 echo "radio_config_id=${radio_md5sum}" >> $hostapd_conf_file
484 }
485
486 mac80211_hostapd_setup_bss() {
487 local phy="$1"
488 local ifname="$2"
489 local macaddr="$3"
490 local type="$4"
491
492 hostapd_cfg=
493 append hostapd_cfg "$type=$ifname" "$N"
494
495 hostapd_set_bss_options hostapd_cfg "$phy" "$vif" || return 1
496 json_get_vars wds wds_bridge dtim_period max_listen_int start_disabled
497
498 set_default wds 0
499 set_default start_disabled 0
500
501 [ "$wds" -gt 0 ] && {
502 append hostapd_cfg "wds_sta=1" "$N"
503 [ -n "$wds_bridge" ] && append hostapd_cfg "wds_bridge=$wds_bridge" "$N"
504 }
505 [ "$staidx" -gt 0 -o "$start_disabled" -eq 1 ] && append hostapd_cfg "start_disabled=1" "$N"
506
507 cat >> /var/run/hostapd-$phy.conf <<EOF
508 $hostapd_cfg
509 bssid=$macaddr
510 ${dtim_period:+dtim_period=$dtim_period}
511 ${max_listen_int:+max_listen_interval=$max_listen_int}
512 EOF
513 }
514
515 mac80211_get_addr() {
516 local phy="$1"
517 local idx="$(($2 + 1))"
518
519 head -n $idx /sys/class/ieee80211/${phy}/addresses | tail -n1
520 }
521
522 mac80211_generate_mac() {
523 local phy="$1"
524 local id="${macidx:-0}"
525
526 local ref="$(cat /sys/class/ieee80211/${phy}/macaddress)"
527 local mask="$(cat /sys/class/ieee80211/${phy}/address_mask)"
528
529 [ "$mask" = "00:00:00:00:00:00" ] && {
530 mask="ff:ff:ff:ff:ff:ff";
531
532 [ "$(wc -l < /sys/class/ieee80211/${phy}/addresses)" -gt $id ] && {
533 addr="$(mac80211_get_addr "$phy" "$id")"
534 [ -n "$addr" ] && {
535 echo "$addr"
536 return
537 }
538 }
539 }
540
541 local oIFS="$IFS"; IFS=":"; set -- $mask; IFS="$oIFS"
542
543 local mask1=$1
544 local mask6=$6
545
546 local oIFS="$IFS"; IFS=":"; set -- $ref; IFS="$oIFS"
547
548 macidx=$(($id + 1))
549 [ "$((0x$mask1))" -gt 0 ] && {
550 b1="0x$1"
551 [ "$id" -gt 0 ] && \
552 b1=$(($b1 ^ ((($id - !($b1 & 2)) << 2)) | 0x2))
553 printf "%02x:%s:%s:%s:%s:%s" $b1 $2 $3 $4 $5 $6
554 return
555 }
556
557 [ "$((0x$mask6))" -lt 255 ] && {
558 printf "%s:%s:%s:%s:%s:%02x" $1 $2 $3 $4 $5 $(( 0x$6 ^ $id ))
559 return
560 }
561
562 off2=$(( (0x$6 + $id) / 0x100 ))
563 printf "%s:%s:%s:%s:%02x:%02x" \
564 $1 $2 $3 $4 \
565 $(( (0x$5 + $off2) % 0x100 )) \
566 $(( (0x$6 + $id) % 0x100 ))
567 }
568
569 find_phy() {
570 [ -n "$phy" -a -d /sys/class/ieee80211/$phy ] && return 0
571 [ -n "$path" ] && {
572 phy="$(iwinfo nl80211 phyname "path=$path")"
573 [ -n "$phy" ] && return 0
574 }
575 [ -n "$macaddr" ] && {
576 for phy in $(ls /sys/class/ieee80211 2>/dev/null); do
577 grep -i -q "$macaddr" "/sys/class/ieee80211/${phy}/macaddress" && return 0
578 done
579 }
580 return 1
581 }
582
583 mac80211_check_ap() {
584 has_ap=1
585 }
586
587 mac80211_iw_interface_add() {
588 local phy="$1"
589 local ifname="$2"
590 local type="$3"
591 local wdsflag="$4"
592 local rc
593 local oldifname
594
595 iw phy "$phy" interface add "$ifname" type "$type" $wdsflag >/dev/null 2>&1
596 rc="$?"
597
598 [ "$rc" = 233 ] && {
599 # Device might have just been deleted, give the kernel some time to finish cleaning it up
600 sleep 1
601
602 iw phy "$phy" interface add "$ifname" type "$type" $wdsflag >/dev/null 2>&1
603 rc="$?"
604 }
605
606 [ "$rc" = 233 ] && {
607 # Keep matching pre-existing interface
608 [ -d "/sys/class/ieee80211/${phy}/device/net/${ifname}" ] && \
609 case "$(iw dev $ifname info | grep "^\ttype" | cut -d' ' -f2- 2>/dev/null)" in
610 "AP")
611 [ "$type" = "__ap" ] && rc=0
612 ;;
613 "IBSS")
614 [ "$type" = "adhoc" ] && rc=0
615 ;;
616 "managed")
617 [ "$type" = "managed" ] && rc=0
618 ;;
619 "mesh point")
620 [ "$type" = "mp" ] && rc=0
621 ;;
622 "monitor")
623 [ "$type" = "monitor" ] && rc=0
624 ;;
625 esac
626 }
627
628 [ "$rc" = 233 ] && {
629 iw dev "$ifname" del >/dev/null 2>&1
630 [ "$?" = 0 ] && {
631 sleep 1
632
633 iw phy "$phy" interface add "$ifname" type "$type" $wdsflag >/dev/null 2>&1
634 rc="$?"
635 }
636 }
637
638 [ "$rc" != 0 ] && {
639 # Device might not support virtual interfaces, so the interface never got deleted in the first place.
640 # Check if the interface already exists, and avoid failing in this case.
641 [ -d "/sys/class/ieee80211/${phy}/device/net/${ifname}" ] && rc=0
642 }
643
644 [ "$rc" != 0 ] && {
645 # Device doesn't support virtual interfaces and may have existing interface other than ifname.
646 oldifname="$(basename "/sys/class/ieee80211/${phy}/device/net"/* 2>/dev/null)"
647 [ "$oldifname" ] && ip link set "$oldifname" name "$ifname" 1>/dev/null 2>&1
648 rc="$?"
649 }
650
651 [ "$rc" != 0 ] && echo "Failed to create interface $ifname"
652 return $rc
653 }
654
655 mac80211_prepare_vif() {
656 json_select config
657
658 json_get_vars ifname mode ssid wds powersave macaddr enable wpa_psk_file vlan_file
659
660 [ -n "$ifname" ] || ifname="wlan${phy#phy}${if_idx:+-$if_idx}"
661 if_idx=$((${if_idx:-0} + 1))
662
663 set_default wds 0
664 set_default powersave 0
665
666 json_select ..
667
668 [ -n "$macaddr" ] || {
669 macaddr="$(mac80211_generate_mac $phy)"
670 macidx="$(($macidx + 1))"
671 }
672
673 json_add_object data
674 json_add_string ifname "$ifname"
675 json_close_object
676
677 [ "$mode" == "ap" ] && {
678 [ -z "$wpa_psk_file" ] && hostapd_set_psk "$ifname"
679 [ -z "$vlan_file" ] && hostapd_set_vlan "$ifname"
680 }
681
682 json_select config
683
684 # It is far easier to delete and create the desired interface
685 case "$mode" in
686 adhoc)
687 mac80211_iw_interface_add "$phy" "$ifname" adhoc || return
688 ;;
689 ap)
690 # Hostapd will handle recreating the interface and
691 # subsequent virtual APs belonging to the same PHY
692 if [ -n "$hostapd_ctrl" ]; then
693 type=bss
694 else
695 type=interface
696 fi
697
698 mac80211_hostapd_setup_bss "$phy" "$ifname" "$macaddr" "$type" || return
699
700 NEWAPLIST="${NEWAPLIST}$ifname "
701 [ -n "$hostapd_ctrl" ] || {
702 ap_ifname="${ifname}"
703 hostapd_ctrl="${hostapd_ctrl:-/var/run/hostapd/$ifname}"
704 }
705 ;;
706 mesh)
707 mac80211_iw_interface_add "$phy" "$ifname" mp || return
708 ;;
709 monitor)
710 mac80211_iw_interface_add "$phy" "$ifname" monitor || return
711 ;;
712 sta)
713 local wdsflag=
714 [ "$enable" = 0 ] || staidx="$(($staidx + 1))"
715 [ "$wds" -gt 0 ] && wdsflag="4addr on"
716 mac80211_iw_interface_add "$phy" "$ifname" managed "$wdsflag" || return
717 if [ "$wds" -gt 0 ]; then
718 iw "$ifname" set 4addr on
719 else
720 iw "$ifname" set 4addr off
721 fi
722 [ "$powersave" -gt 0 ] && powersave="on" || powersave="off"
723 iw "$ifname" set power_save "$powersave"
724 ;;
725 esac
726
727 case "$mode" in
728 monitor|mesh)
729 [ "$auto_channel" -gt 0 ] || iw dev "$ifname" set channel "$channel" $iw_htmode
730 ;;
731 esac
732
733 if [ "$mode" != "ap" ]; then
734 # ALL ap functionality will be passed to hostapd
735 # All interfaces must have unique mac addresses
736 # which can either be explicitly set in the device
737 # section, or automatically generated
738 ip link set dev "$ifname" address "$macaddr"
739 fi
740
741 json_select ..
742 }
743
744 mac80211_setup_supplicant() {
745 local enable=$1
746 local add_sp=0
747 local spobj="$(ubus -S list | grep wpa_supplicant.${ifname})"
748
749 [ "$enable" = 0 ] && {
750 ubus call wpa_supplicant.${phy} config_remove "{\"iface\":\"$ifname\"}"
751 ip link set dev "$ifname" down
752 iw dev "$ifname" del
753 return 0
754 }
755
756 wpa_supplicant_prepare_interface "$ifname" nl80211 || {
757 iw dev "$ifname" del
758 return 1
759 }
760 if [ "$mode" = "sta" ]; then
761 wpa_supplicant_add_network "$ifname"
762 else
763 wpa_supplicant_add_network "$ifname" "$freq" "$htmode" "$noscan"
764 fi
765
766 NEWSPLIST="${NEWSPLIST}$ifname "
767
768 if [ "${NEWAPLIST%% *}" != "${OLDAPLIST%% *}" ]; then
769 [ "$spobj" ] && ubus call wpa_supplicant config_remove "{\"iface\":\"$ifname\"}"
770 add_sp=1
771 fi
772 [ -z "$spobj" ] && add_sp=1
773
774 NEW_MD5_SP=$(test -e "${_config}" && md5sum ${_config})
775 OLD_MD5_SP=$(uci -q -P /var/state get wireless._${phy}.md5_${ifname})
776 if [ "$add_sp" = "1" ]; then
777 wpa_supplicant_run "$ifname" "$hostapd_ctrl"
778 else
779 [ "${NEW_MD5_SP}" == "${OLD_MD5_SP}" ] || ubus call $spobj reload
780 fi
781 uci -q -P /var/state set wireless._${phy}.md5_${ifname}="${NEW_MD5_SP}"
782 return 0
783 }
784
785 mac80211_setup_supplicant_noctl() {
786 local enable=$1
787 local spobj="$(ubus -S list | grep wpa_supplicant.${ifname})"
788 wpa_supplicant_prepare_interface "$ifname" nl80211 || {
789 iw dev "$ifname" del
790 return 1
791 }
792
793 wpa_supplicant_add_network "$ifname" "$freq" "$htmode" "$noscan"
794
795 NEWSPLIST="${NEWSPLIST}$ifname "
796 [ "$enable" = 0 ] && {
797 ubus call wpa_supplicant config_remove "{\"iface\":\"$ifname\"}"
798 ip link set dev "$ifname" down
799 return 0
800 }
801 if [ -z "$spobj" ]; then
802 wpa_supplicant_run "$ifname"
803 else
804 ubus call $spobj reload
805 fi
806 }
807
808 mac80211_prepare_iw_htmode() {
809 case "$htmode" in
810 VHT20|HT20) iw_htmode=HT20;;
811 HT40*|VHT40|VHT160)
812 case "$band" in
813 2g)
814 case "$htmode" in
815 HT40+) iw_htmode="HT40+";;
816 HT40-) iw_htmode="HT40-";;
817 *)
818 if [ "$channel" -lt 7 ]; then
819 iw_htmode="HT40+"
820 else
821 iw_htmode="HT40-"
822 fi
823 ;;
824 esac
825 ;;
826 *)
827 case "$(( ($channel / 4) % 2 ))" in
828 1) iw_htmode="HT40+" ;;
829 0) iw_htmode="HT40-";;
830 esac
831 ;;
832 esac
833 [ "$auto_channel" -gt 0 ] && iw_htmode="HT40+"
834 ;;
835 VHT80)
836 iw_htmode="80MHZ"
837 ;;
838 NONE|NOHT)
839 iw_htmode="NOHT"
840 ;;
841 *) iw_htmode="" ;;
842 esac
843 }
844
845 mac80211_setup_adhoc() {
846 local enable=$1
847 json_get_vars bssid ssid key mcast_rate
848
849 NEWUMLIST="${NEWUMLIST}$ifname "
850
851 [ "$enable" = 0 ] && {
852 ip link set dev "$ifname" down
853 return 0
854 }
855
856 keyspec=
857 [ "$auth_type" = "wep" ] && {
858 set_default key 1
859 case "$key" in
860 [1234])
861 local idx
862 for idx in 1 2 3 4; do
863 json_get_var ikey "key$idx"
864
865 [ -n "$ikey" ] && {
866 ikey="$(($idx - 1)):$(prepare_key_wep "$ikey")"
867 [ $idx -eq $key ] && ikey="d:$ikey"
868 append keyspec "$ikey"
869 }
870 done
871 ;;
872 *)
873 append keyspec "d:0:$(prepare_key_wep "$key")"
874 ;;
875 esac
876 }
877
878 brstr=
879 for br in $basic_rate_list; do
880 wpa_supplicant_add_rate brstr "$br"
881 done
882
883 mcval=
884 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
885
886 iw dev "$ifname" set type ibss
887 iw dev "$ifname" ibss join "$ssid" $freq $iw_htmode fixed-freq $bssid \
888 beacon-interval $beacon_int \
889 ${brstr:+basic-rates $brstr} \
890 ${mcval:+mcast-rate $mcval} \
891 ${keyspec:+keys $keyspec}
892 }
893
894 mac80211_setup_mesh() {
895 local enable=$1
896 json_get_vars ssid mesh_id mcast_rate
897
898 NEWUMLIST="${NEWUMLIST}$ifname "
899
900 [ "$enable" = 0 ] && {
901 ip link set dev "$ifname" down
902 return 0
903 }
904
905 mcval=
906 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
907 [ -n "$mesh_id" ] && ssid="$mesh_id"
908
909 iw dev "$ifname" mesh join "$ssid" freq $freq $iw_htmode \
910 ${mcval:+mcast-rate $mcval} \
911 beacon-interval $beacon_int
912 }
913
914 mac80211_setup_vif() {
915 local name="$1"
916 local failed
917 local action=up
918
919 json_select data
920 json_get_vars ifname
921 json_select ..
922
923 json_select config
924 json_get_vars mode
925 json_get_var vif_txpower
926 json_get_var vif_enable enable 1
927
928 [ "$vif_enable" = 1 ] || action=down
929 if [ "$mode" != "ap" ] || [ "$ifname" = "$ap_ifname" ]; then
930 ip link set dev "$ifname" "$action" || {
931 wireless_setup_vif_failed IFUP_ERROR
932 json_select ..
933 return
934 }
935 [ -z "$vif_txpower" ] || iw dev "$ifname" set txpower fixed "${vif_txpower%%.*}00"
936 fi
937
938 case "$mode" in
939 mesh)
940 wireless_vif_parse_encryption
941 [ -z "$htmode" ] && htmode="NOHT";
942 if [ "$wpa" -gt 0 -o "$auto_channel" -gt 0 ] || chan_is_dfs "$phy" "$channel"; then
943 mac80211_setup_supplicant $vif_enable || failed=1
944 else
945 mac80211_setup_mesh $vif_enable
946 fi
947 for var in $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING; do
948 json_get_var mp_val "$var"
949 [ -n "$mp_val" ] && iw dev "$ifname" set mesh_param "$var" "$mp_val"
950 done
951 ;;
952 adhoc)
953 wireless_vif_parse_encryption
954 if [ "$wpa" -gt 0 -o "$auto_channel" -gt 0 ]; then
955 mac80211_setup_supplicant_noctl $vif_enable || failed=1
956 else
957 mac80211_setup_adhoc $vif_enable
958 fi
959 ;;
960 sta)
961 mac80211_setup_supplicant $vif_enable || failed=1
962 ;;
963 esac
964
965 json_select ..
966 [ -n "$failed" ] || wireless_add_vif "$name" "$ifname"
967 }
968
969 get_freq() {
970 local phy="$1"
971 local channel="$2"
972 local band="$3"
973
974 case "$band" in
975 2g) band="1:";;
976 5g) band="2:";;
977 60g) band="3:";;
978 6g) band="4:";;
979 esac
980
981 iw "$phy" info | awk -v band="$band" -v channel="[$channel]" '
982
983 $1 ~ /Band/ {
984 band_match = band == $2
985 }
986
987 band_match && $3 == "MHz" && $4 == channel {
988 print $2
989 exit
990 }
991 '
992 }
993
994
995 chan_is_dfs() {
996 local phy="$1"
997 local chan="$2"
998 iw "$phy" info | grep -E -m1 "(\* ${chan:-....} MHz${chan:+|\\[$chan\\]})" | grep -q "MHz.*radar detection"
999 return $!
1000 }
1001
1002 mac80211_vap_cleanup() {
1003 local service="$1"
1004 local vaps="$2"
1005
1006 for wdev in $vaps; do
1007 [ "$service" != "none" ] && ubus call ${service} config_remove "{\"iface\":\"$wdev\"}"
1008 ip link set dev "$wdev" down 2>/dev/null
1009 iw dev "$wdev" del
1010 done
1011 }
1012
1013 mac80211_interface_cleanup() {
1014 local phy="$1"
1015 local primary_ap=$(uci -q -P /var/state get wireless._${phy}.aplist)
1016 primary_ap=${primary_ap%% *}
1017
1018 mac80211_vap_cleanup hostapd "${primary_ap}"
1019 mac80211_vap_cleanup wpa_supplicant "$(uci -q -P /var/state get wireless._${phy}.splist)"
1020 mac80211_vap_cleanup none "$(uci -q -P /var/state get wireless._${phy}.umlist)"
1021 }
1022
1023 mac80211_set_noscan() {
1024 hostapd_noscan=1
1025 }
1026
1027 drv_mac80211_cleanup() {
1028 hostapd_common_cleanup
1029 }
1030
1031 drv_mac80211_setup() {
1032 json_select config
1033 json_get_vars \
1034 phy macaddr path \
1035 country chanbw distance \
1036 txpower antenna_gain \
1037 rxantenna txantenna \
1038 frag rts beacon_int:100 htmode
1039 json_get_values basic_rate_list basic_rate
1040 json_get_values scan_list scan_list
1041 json_select ..
1042
1043 find_phy || {
1044 echo "Could not find PHY for device '$1'"
1045 wireless_set_retry 0
1046 return 1
1047 }
1048
1049 wireless_set_data phy="$phy"
1050 [ -z "$(uci -q -P /var/state show wireless._${phy})" ] && uci -q -P /var/state set wireless._${phy}=phy
1051
1052 OLDAPLIST=$(uci -q -P /var/state get wireless._${phy}.aplist)
1053 OLDSPLIST=$(uci -q -P /var/state get wireless._${phy}.splist)
1054 OLDUMLIST=$(uci -q -P /var/state get wireless._${phy}.umlist)
1055
1056 local wdev
1057 local cwdev
1058 local found
1059
1060 for wdev in $(list_phy_interfaces "$phy"); do
1061 found=0
1062 for cwdev in $OLDAPLIST $OLDSPLIST $OLDUMLIST; do
1063 if [ "$wdev" = "$cwdev" ]; then
1064 found=1
1065 break
1066 fi
1067 done
1068 if [ "$found" = "0" ]; then
1069 ip link set dev "$wdev" down
1070 iw dev "$wdev" del
1071 fi
1072 done
1073
1074 # convert channel to frequency
1075 [ "$auto_channel" -gt 0 ] || freq="$(get_freq "$phy" "$channel" "$band")"
1076
1077 [ -n "$country" ] && {
1078 iw reg get | grep -q "^country $country:" || {
1079 iw reg set "$country"
1080 sleep 1
1081 }
1082 }
1083
1084 hostapd_conf_file="/var/run/hostapd-$phy.conf"
1085
1086 no_ap=1
1087 macidx=0
1088 staidx=0
1089
1090 [ -n "$chanbw" ] && {
1091 for file in /sys/kernel/debug/ieee80211/$phy/ath9k*/chanbw /sys/kernel/debug/ieee80211/$phy/ath5k/bwmode; do
1092 [ -f "$file" ] && echo "$chanbw" > "$file"
1093 done
1094 }
1095
1096 set_default rxantenna 0xffffffff
1097 set_default txantenna 0xffffffff
1098 set_default distance 0
1099 set_default antenna_gain 0
1100
1101 [ "$txantenna" = "all" ] && txantenna=0xffffffff
1102 [ "$rxantenna" = "all" ] && rxantenna=0xffffffff
1103
1104 iw phy "$phy" set antenna $txantenna $rxantenna >/dev/null 2>&1
1105 iw phy "$phy" set antenna_gain $antenna_gain >/dev/null 2>&1
1106 iw phy "$phy" set distance "$distance" >/dev/null 2>&1
1107
1108 if [ -n "$txpower" ]; then
1109 iw phy "$phy" set txpower fixed "${txpower%%.*}00"
1110 else
1111 iw phy "$phy" set txpower auto
1112 fi
1113
1114 [ -n "$frag" ] && iw phy "$phy" set frag "${frag%%.*}"
1115 [ -n "$rts" ] && iw phy "$phy" set rts "${rts%%.*}"
1116
1117 has_ap=
1118 hostapd_ctrl=
1119 ap_ifname=
1120 hostapd_noscan=
1121 for_each_interface "ap" mac80211_check_ap
1122
1123 rm -f "$hostapd_conf_file"
1124
1125 for_each_interface "sta adhoc mesh" mac80211_set_noscan
1126 [ -n "$has_ap" ] && mac80211_hostapd_setup_base "$phy"
1127
1128 mac80211_prepare_iw_htmode
1129 for_each_interface "sta adhoc mesh monitor" mac80211_prepare_vif
1130 NEWAPLIST=
1131 for_each_interface "ap" mac80211_prepare_vif
1132 NEW_MD5=$(test -e "${hostapd_conf_file}" && md5sum ${hostapd_conf_file})
1133 OLD_MD5=$(uci -q -P /var/state get wireless._${phy}.md5)
1134 if [ "${NEWAPLIST}" != "${OLDAPLIST}" ]; then
1135 mac80211_vap_cleanup hostapd "${OLDAPLIST}"
1136 fi
1137 [ -n "${NEWAPLIST}" ] && mac80211_iw_interface_add "$phy" "${NEWAPLIST%% *}" __ap
1138 local add_ap=0
1139 local primary_ap=${NEWAPLIST%% *}
1140 [ -n "$hostapd_ctrl" ] && {
1141 local no_reload=1
1142 if [ -n "$(ubus list | grep hostapd.$primary_ap)" ]; then
1143 no_reload=0
1144 [ "${NEW_MD5}" = "${OLD_MD5}" ] || {
1145 ubus call hostapd.$primary_ap reload
1146 no_reload=$?
1147 if [ "$no_reload" != "0" ]; then
1148 mac80211_vap_cleanup hostapd "${OLDAPLIST}"
1149 mac80211_vap_cleanup wpa_supplicant "$(uci -q -P /var/state get wireless._${phy}.splist)"
1150 mac80211_vap_cleanup none "$(uci -q -P /var/state get wireless._${phy}.umlist)"
1151 sleep 2
1152 mac80211_iw_interface_add "$phy" "${NEWAPLIST%% *}" __ap
1153 for_each_interface "sta adhoc mesh monitor" mac80211_prepare_vif
1154 fi
1155 }
1156 fi
1157 if [ "$no_reload" != "0" ]; then
1158 add_ap=1
1159 ubus wait_for hostapd
1160 local hostapd_res="$(ubus call hostapd config_add "{\"iface\":\"$primary_ap\", \"config\":\"${hostapd_conf_file}\"}")"
1161 ret="$?"
1162 [ "$ret" != 0 -o -z "$hostapd_res" ] && {
1163 wireless_setup_failed HOSTAPD_START_FAILED
1164 return
1165 }
1166 wireless_add_process "$(jsonfilter -s "$hostapd_res" -l 1 -e @.pid)" "/usr/sbin/hostapd" 1 1
1167 fi
1168 }
1169 uci -q -P /var/state set wireless._${phy}.aplist="${NEWAPLIST}"
1170 uci -q -P /var/state set wireless._${phy}.md5="${NEW_MD5}"
1171
1172 [ "${add_ap}" = 1 ] && sleep 1
1173 for_each_interface "ap" mac80211_setup_vif
1174
1175 NEWSPLIST=
1176 NEWUMLIST=
1177
1178 for_each_interface "sta adhoc mesh monitor" mac80211_setup_vif
1179
1180 uci -q -P /var/state set wireless._${phy}.splist="${NEWSPLIST}"
1181 uci -q -P /var/state set wireless._${phy}.umlist="${NEWUMLIST}"
1182
1183 local foundvap
1184 local dropvap=""
1185 for oldvap in $OLDSPLIST; do
1186 foundvap=0
1187 for newvap in $NEWSPLIST; do
1188 [ "$oldvap" = "$newvap" ] && foundvap=1
1189 done
1190 [ "$foundvap" = "0" ] && dropvap="$dropvap $oldvap"
1191 done
1192 [ -n "$dropvap" ] && mac80211_vap_cleanup wpa_supplicant "$dropvap"
1193 wireless_set_up
1194 }
1195
1196 _list_phy_interfaces() {
1197 local phy="$1"
1198 if [ -d "/sys/class/ieee80211/${phy}/device/net" ]; then
1199 ls "/sys/class/ieee80211/${phy}/device/net" 2>/dev/null;
1200 else
1201 ls "/sys/class/ieee80211/${phy}/device" 2>/dev/null | grep net: | sed -e 's,net:,,g'
1202 fi
1203 }
1204
1205 list_phy_interfaces() {
1206 local phy="$1"
1207
1208 for dev in $(_list_phy_interfaces "$phy"); do
1209 readlink "/sys/class/net/${dev}/phy80211" | grep -q "/${phy}\$" || continue
1210 echo "$dev"
1211 done
1212 }
1213
1214 drv_mac80211_teardown() {
1215 json_select data
1216 json_get_vars phy
1217 json_select ..
1218 [ -n "$phy" ] || {
1219 echo "Bug: PHY is undefined for device '$1'"
1220 return 1
1221 }
1222
1223 mac80211_interface_cleanup "$phy"
1224 uci -q -P /var/state revert wireless._${phy}
1225 }
1226
1227 add_driver mac80211